
	section .text
	align 1

	global _xtea_cipher

DELTA_MSW equ 9E37h
DELTA_LSW equ 79B9h

_xtea_cipher             ; (byte *eight_bytes_in_out, byte *16_byte_key)
	pshm z

	xgex                 ; qword v, aka dword _y and _z
	aix  # 4             ; start with &_z (toggles in crunch())

	lde  # 32            ; _n = 32, upper byte is _toggle = 0

	pshm d,e,x,y         ; D == _key aka 'k'
	                     ; E == _n & _toggle
	                     ; XY == _tmp
	clre
	clrd
	pshm e,d             ; _sum = 0

	tsz
_sum    equ 0     ; 4 bytes
_tmp    equ 4     ; 4 bytes
_toggle equ 8     ; byte
_n      equ 9     ; byte
_key    equ 10    ; ptr  ---  12 bytes total

L0
	ldab 3+_sum,z        ; contains sum & 3
	aslb
	aslb                 ; dword index
	bsr  crunch          ; y += ((z<<4 ^ z>>5) + z) ^ (sum + k[sum&3]);

	pulm e,d             ; simpler to pop and push back _sum
	addd # DELTA_LSW
	adce # DELTA_MSW
	pshm e,d             ; sum += delta

	ldab 2+_sum,z        ; contains (sum >> 11) & 3
	lsrb                 ; dword index, thus (sum >> 9) & 0xC
	bsr  crunch          ; z += ((y<<4 ^ y>>5) + y) ^ (sum + k[sum>>11 & 3]);

	dec  _n,z            ; 32 times
	bne  L0

	ais  #+12            ; purge locals
	pulm z
	rts

	; y += ((z<<4 ^ z>>5) + z) ^ (sum + k[??? & 3]);
	; or, z and y swapped, every other time

crunch
	andb # 0Ch           ; just these bits, dword k[ & 3]
	ldy  _key,z       
	aby                  ; &k[??? & 3]

	; (z<<4 ^ z>>5) + z

	lde  0,x             ; _z or _y at ix
	ldd  2,x
	clr  0+_tmp,z        ; 00000000 vutsrqpo nmlkjihg fedcba98 76543210
	asld
	role
	rol  0+_tmp,z        ; 
	asld
	role
	rol  0+_tmp,z
	asld
	role
	rol  0+_tmp,z        ; 00000vut srqponml kjihgfed cba98765 43210000
	ste  1+_tmp,z
	staa 3+_tmp,z        ; 00000vut srqponml kjihgfed cba98765 == x >> 5
	asld
	role                 ; rqponmlk jihgfedc ba987654 32100000 == x << 4
	eore 0+_tmp,z
	eord 2+_tmp,z        ; (<< ^ >>)
	addd 2,x
	adce 0,x             ; + x
	ste  0+_tmp,z
	std  2+_tmp,z        ; (x << 4) ^ (x >> 5) + x

	; sum + k[??? & 3]

	lde  0+_sum,z
	ldd  2+_sum,z
	addd 2,y
	adce 0,y             ; sum + k[]

	; _y += () ^ ();

	eore 0+_tmp,z
	eord 2+_tmp,z        ; () ^ ()

	com  _toggle,z       ; swap x between &_y and &_z
	bne  L1
	aix  # +8            ; +8 -4 == +4
L1
	aix  # -4            ; or just -4

	addd 2,x             ; now _y or _z at ix
	adce 0,x
	ste  0,x
	std  2,x             ; _? += () ^ ()

	rts

