
	section .text2 ; not fncallable
	align  1

overflow
	ldd #0FFFFh   ; USHORT_MAX
ret
	rts

	global _ihypot

_ihypot           ; word ihypot(word a_in_E, word b_in_D);

	tste
	beq  ret      ; a was 0, result is b already in D
	xgde          ; exchange a and b, no effect on result
	tste
	beq  ret      ; b was 0, result is a now in D

	xgdx          ; save b
	ted           ; E and D both have a
	emul          ; ED = a * a
	pshm e,d      ; intermediate result (a^2) into stack (E at top)

	xgdx          ; restore b
	tde           ; E and D both have b
	emul          ; ED has (b^2)

	tsx           ; X now free to point to locals
	addd 2,x
	adce 0,x      ; ED has a^2 + b^2
	ais  #+4      ; purge temporaries
	bcs  overflow

	; no overflow, fall thru to square root.

	;
	; hats off to old man Jack Crenshaw of embedded.com
	;
	; some extra dancing, word sized variables
	; are used for first 28 bits of input.
	;

	global _isqrt

_isqrt            ; word isqrt(dword ED)

	tste          ; MSword all zero ?
	beq  sqrt_16  ; abridged version will do

	xgex          ; input MSWord
	pshm d        ; input LSWord

	clre          ; rem = 0
	clrd          ; root = 0. really the 'divisor'

	bsr  churn_8  ; first 16 bits of input from X

	pulm x        ; input LSWord

	ldy  # 6
	bsr  churn_y  ; next 12 bits of input, zeroes walk in from right

	; 4 bits of input left. wide 'rem' and 'root' needed

	; strange days:
	; 
	; rem  is 24 bits in B:E (0x00????)
	; root is 24 bits at 1,x (0x00????)
	; what is left of input is at 4 msbits at 0,x (0x?0)
	; A is loop "counter", do twice
	; A also sets carry to "1" from the ROLD below

	pshm d,x      ; 12 LSbits of ix already 0
	tsx           ; input 4 msbits at 0,x and 'root' 24 bits at 1,x

	ldd # 0C000h  ; A=C0 and B=00
L6
	asl  0,x      ; only 4 MSbits of input left
	role
	rolb          ; input and rem shifted

	aslw 2,x      ; 'root' at offsets [1], [2] and [3]. zero into lsbit
	rolw 0,x      ; rotates both 'root' MSbyte and input MSbits
	role
	rold          ; ROLD. input and rem shifted twice, root once, carry set

	sbce 2,x      ; note use of carry, root lsbit is still 0
	sbcb 1,x
	bcc  L7
	adce 2,x      ; undo
	adcb 1,x
	bra  L8       ; root LSbit stays as 0
L7
	inc  3,x      ; set the LSbit now, no carry here
	incw 2,x      ; increment again, carry now possible
	bne  L8
	inc  1,x
L8
	tsta
	bmi  L6       ; A is 1000'000? or 0000'00?? at this point

	pulm e,d
	lsre
	rord          ; final fixup, it was 'divisor' really before this.

	; XXX clean that up, someday.

	rts

sqrt_16

	xgdx          ; input in IX
	clre          ; 'rem'
	clrd          ; 'root'
	bsr  churn_8
	lsrd
	rts

churn_8
	ldy  # 8      ; worth of 16 bits of input

churn_y
	xgdx
	asld          ; another 2 bits of input from IX
	role
	asld
	role          ; into 'rem'
	xgdx

	asld          ; 'root'
	addd # 1
	sde
	bcc  L3
	ade           ; undo
	addd #-2      ; and undo both increments, from above and below
L3
	addd # 1
	aiy  #-1
	bne  churn_y  ; another pair of bits
	rts

	end

